//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#pragma hdrstop
#include "Unit1.h"

#define pre_FILE "test.bmp"			//INPUT BMP FILE
#define pre_RULEFILE "rules.txt"	//INPUT RULE FILE
#define MAXRULE 50					//Max. num. of rules
#define MAXGATE 20					//Max. num. of gates
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
rule rules[MAXRULE];	//store rule pointers here
HDC memDC[MAXGATE];		//Bitmaps for logic gates
HBITMAP memBM[MAXGATE];
int dir[MAXGATE];			//direction

//Rotate picture by90 degree
//num= num. of rotation
void TForm1::rotate(BYTE*memp,int num){
	BYTE pic[10][10];
	BYTE pic2[10][10];
	int x,y,z,p=0;
	for(y=0;y<10;y++){
		while(memp[p]!=':')p++;
		p++;
		for(x=0;x<10;x++){
			pic[y][x]=memp[p++];
		}
	}
	switch(num){
		case 0:
			for(y=0;y<10;y++) for(x=0;x<10;x++) pic2[x][y]=pic[x][y];
			break;
		case 1:
			for(y=0;y<10;y++) for(x=0;x<10;x++) pic2[y][x]=pic[x][y];
			break;
		case 2:
			for(y=0;y<10;y++) for(x=0;x<10;x++) pic2[9-x][9-y]=pic[x][y];
			break;
		case 3:
			for(y=0;y<10;y++) for(x=0;x<10;x++) pic2[9-x][9-y]=pic[y][x];
			break;
	}
	p=0;
	for(y=0;y<10;y++)
		for(x=0;x<10;x++)
			memp[p++]=pic2[y][x];
}

//Load the Bitmaps of the logic gates
void TForm1::LoadGates(){
	int x,y,z,rot;
	AnsiString name[5];
	int pos=0;
	int fileHandler;
	BYTE*memp;
	int p=0;
	int r,g,b;
	name[0]="AND.pic";
	name[1]="OR.pic";
	name[2]="NOT.pic";
	name[3]="CROSS.pic";
	name[4]="DFLOP.pic";

	HDC hdc=Canvas->Handle;

	for(z=0;z<5;z++){
		for(rot=0;rot<4;rot++){
			memDC[pos] = CreateCompatibleDC ( hdc );
			memBM[pos] = CreateCompatibleBitmap ( hdc,10,10 );
			SelectObject ( memDC[pos], memBM[pos] );
			dir[pos]=z;

			fileHandler = FileOpen(name[z], GENERIC_READ);
			if(fileHandler==-1) ShowMessage("BMP.PIC - File Open ERROR");
			else {
				memp=new BYTE [1000];
				FileRead(fileHandler, memp, 1000);
				FileClose(fileHandler);
				rotate(memp,rot);
				p=0;
				for(y=0;y<10;y++){
					for(x=0;x<10;x++){
						r=0;g=0;b=0;
						switch(memp[p++]){
							case 'R': r=0xFF;
								break;
							case 'G': g=0xFF;
								break;
							case 'B': b=0xFF;
								break;
							case 'Y': r=0xFF; g=0xFF;
								break;
							case 'C': b=0xFF; g=0xFF;
								break;
							case 'M': b=0xFF; r=0xFF;
								break;
							case '0': r=0xFF; g=0xFF; b=0xFF;
								break;
							case ' ': r=0xFF; g=0xFF; b=0xFF;
								break;
							default:
								break;
						}
						SetPixel(memDC[pos],x,y,RGB(r,g,b));
					}
				}
				delete memp;
			}
			pos++;
		}
	}
	memDC[13]=memDC[16];
	memBM[13]=memBM[16];
	dir[13]=dir[16];
}

//Dispay the Bitmaps of the logic gates
//if corner==1 ->plot to the current color display
//gate : 0->11;
void TForm1::PlotGates(int x,int y,int gate,int corner){
	HDC hdc=Canvas->Handle;
	x*=10;y*=10;
	if(!corner)
		BitBlt(hdc,x,y,10,10,memDC[gate],0,0,SRCCOPY);
	else{
		x=515;y=480;
		BitBlt(hdc,x,y,10,10,memDC[gate],0,0,SRCCOPY);
    }
}

//Process rule.txt file - parsing
void TForm1::Ruleparse(BYTE*mem){
	int ruletomppoi=-1;
	int pos=0;
	int pre,suc;
	int org,andg;
	int ch;
	while(mem[pos]&&(mem[pos]!='.')){
		pre=mem[pos++];
		//Filter remarks
		if(pre=='%'){
			while((mem[pos])&&(mem[pos]!=10))pos++;
			if(!mem[pos])return;
			pos++;
			continue;
			//pre=mem[pos++];
		}
		//First meaningful char
		if((pre>'A'-1)&&(pre<'I'))pre-=65;
		else{ ShowMessage("RULES: Parse Error 1");return;}
		if(mem[pos++]!=':'){ ShowMessage("RULES: Parse Error 2");return;}
		suc=mem[pos++];
		if((suc>'A'-1)&&(suc<'I'))suc-=65;
		else{ ShowMessage("RULES: Parse Error 3");return;}
		ruletomppoi++;
		rules[ruletomppoi].valid=1;
		rules[ruletomppoi].prec=pre;
		rules[ruletomppoi].succ=suc;
		rules[ruletomppoi].invs=-1;
		for(andg=0;andg<8;andg++){
			for(org=0;org<8;org++){
				rules[ruletomppoi].cond[org][andg].valid=0;
			}
		}
		if(mem[pos]==13)pos+=2;
		else if(mem[pos]=='<'){
			pos++;org=0;andg=0;
			do{
				ch=mem[pos++];
				if((ch>'0'-1)&&(ch<'9'+1)){
					rules[ruletomppoi].cond[org][andg].num=ch-'0';
					ch=mem[pos++];
					if((ch>'A'-1)&&(ch<'I')){
						rules[ruletomppoi].cond[org][andg].elem=ch-'A';
					}else{ ShowMessage("RULES: Parse Error 4");return;}
				}else{
					rules[ruletomppoi].cond[org][andg].num=1;
					if((ch>'A'-1)&&(ch<'I')){
						rules[ruletomppoi].cond[org][andg].elem=ch-'A';
					}else{ ShowMessage("RULES: Parse Error 5");return;}
				}
				rules[ruletomppoi].cond[org][andg].valid=1;
				andg++;
				if(andg>7){ShowMessage("RULES: Parse Error 6");return;}
				if(mem[pos]=='|'){
					pos++;andg=0;org++;
					if(org>7){ShowMessage("RULES: Parse Error 7");return;}
				}
				ch=mem[pos];
			}while((ch!=0)&&(ch!=13)&&(ch!=':'));
			if(ch==13)pos+=2;
			if(ch==':'){
				pos++;
				ch=mem[pos]; pos+=3;
				if((ch>'A'-1)&&(ch<'I')){
						rules[ruletomppoi].invs=ch-'A';
				}else{ ShowMessage("RULES: Parse Error 8");return;}
			}
		}
	}
	if(!pos)ShowMessage("No rules defined");
}

//Load /Reload from BMP
void TForm1::Load(){
	int x,y,pos,szin;
	int fileHandler;
	char str[100];
	BYTE*memp;
		for (x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			X[x][y]=0;
		}
	}
	//Load BMP
	fileHandler = FileOpen(iFILE, GENERIC_READ);
	if(fileHandler==-1) ShowMessage("BMP - File Open ERROR");
	else {
		memp=new BYTE [10000];
		FileRead(fileHandler, memp, 10000);
		FileClose(fileHandler);

		pos=54;
		for(y=49;y>-1;y--){
			for(x=0;x<50;x++){
				szin=0;
				if(memp[pos++]==0xFF)szin+=0xFF0000;
				//else if(memp[pos-1]!=0x00)ShowMessage("AA");
				if(memp[pos++]==0xFF)szin+=0x00FF00;
				//else if(memp[pos-1]!=0x00)ShowMessage("AA");
				if(memp[pos++]==0xFF)szin+=0x0000FF;
				//else if(memp[pos-1]!=0x00)ShowMessage("AA");
				//sprintf(str,"%X",szin);
				//ShowMessage(str);
				switch(szin){
				case 0x0000FF:
					X[x][y]=1;
					break;
				case 0x00FF00:
					X[x][y]=2;
					break;
				case 0xFF0000:
					X[x][y]=3;
					break;
				case 0x00FFFF:
					X[x][y]=4;
					break;
				case 0xFF00FF:
					X[x][y]=5;
					break;
				case 0xFFFF00:
					X[x][y]=6;
					break;
				case 0x000000:
					X[x][y]=7;
					break;
				default:
					//if(szin!=0xFFFFFF)ShowMessage("AAA");
					X[x][y]=0;
					break;
				}
			}
			pos+=2;
		}
		delete memp;
	}
	//Copy
	for(x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			Xold[x][y]=X[x][y];
		}
	}
	DrawOut(1);
	//Load Rules
	for(x=0;x<MAXRULE;x++){
		rules[x].valid=0;
	}
	fileHandler = FileOpen(iRULEFILE, GENERIC_READ);
	if(fileHandler==-1) ShowMessage("RULES - File Open ERROR");
	else {
		memp=new BYTE [10000];
		for(x=0;x<10000;x++)memp[x]=0;
		FileRead(fileHandler, memp, 10000);
		FileClose(fileHandler);
		Ruleparse(memp);//Process rules
		delete memp;		
	}
	//LGM mode: reload X from .dot file
	if(LGM){
		int x=0,y,p;
		char name[100];
		while(iFILE[x]!='.'){name[x]=iFILE[x]; x++;}
		name[x]='.';name[x+1]='d';name[x+2]='o';name[x+3]='t';name[x+4]=0;

		FILE*f=fopen(name,"rb");
		if(f==NULL) ShowMessage("LOAD .dot file - File not found");
		else {
			for(x=0;x<SIZE;x++)
				for(y=0;y<SIZE;y++)
					Xold[x][y]=X[x][y]=getc(f);
			fclose(f);
		}
	}
	DrawOut(1);	
}

//Number of selected neighbours
//n=type if n==-1->counts any types
int TForm1::NeN(int x,int y,int n){
	int balx,jobbx,fely,ley,num;
	balx=x-1;if(balx<0){balx=SIZE-1;}
	jobbx=x+1;if(jobbx>SIZE-1){jobbx=0;}
	fely=y+1;if(fely>SIZE-1){fely=0;}
	ley=y-1;if(ley<0){ley=SIZE-1;}
	num=0;
	if(n==-1){
		if(X[balx][fely])num++;
		if(X[x][fely])num++;
		if(X[jobbx][fely])num++;
		if(X[balx][y])num++;
		if(X[jobbx][y])num++;
		if(X[balx][ley])num++;
		if(X[x][ley])num++;
		if(X[jobbx][ley])num++;
		return(num);
	}else{
		if(X[balx][fely]==n)num++;
		if(X[x][fely]==n)num++;
		if(X[jobbx][fely]==n)num++;
		if(X[balx][y]==n)num++;
		if(X[jobbx][y]==n)num++;
		if(X[balx][ley]==n)num++;
		if(X[x][ley]==n)num++;
		if(X[jobbx][ley]==n)num++;
		return(num);
	}
}

//Color display
void TForm1::Szin(){
	int m,n;
	RECT r;
	r.left=515;
	r.top=480;
	r.right=525;
	r.bottom=490;
	if(SZIN>99){
		PlotGates(0,0,SZIN-100,1);
		return;
	}
	Canvas->Brush->Color=0xd0d0d0;
	Canvas->FillRect(r);
	switch(SZIN){
		case 1:
			Canvas->Brush->Color=0x0000FF;
			Canvas->Pen->Color=0x0000FF;
			break;
		case 2:
			Canvas->Brush->Color=0x00FF00;
			Canvas->Pen->Color=0x00FF00;
			break;
		case 3:
			Canvas->Brush->Color=0xFF0000;
			Canvas->Pen->Color=0xFF0000;
			break;
		case 4:
			Canvas->Brush->Color=0x00FFFF;
			Canvas->Pen->Color=0x00FFFF;
			break;
		case 5:
			Canvas->Brush->Color=0xFF00FF;
			Canvas->Pen->Color=0xFF00FF;
			break;
		case 6:
			Canvas->Brush->Color=0xFFFF00;
			Canvas->Pen->Color=0xFFFF00;
			break;
		case 7:
			Canvas->Brush->Color=0x000000;
			Canvas->Pen->Color=0x000000;
			break;
		case 0:
			Canvas->Brush->Color=0xFFFFFF;
			Canvas->Pen->Color=0xFFFFFF;
			break;
		default:
			break;
	}
	if(SZIN<100){
		m=515;n=480;
		Canvas->Pie(m,n,m+10,n+10,m,n,m,n);
	}
}

//redraw the window
void TForm1::DrawOut(int init)
{
	int x,y,m,n;
	RECT r;
	r.left=0;
	r.top=0;
	r.right=500;
	r.bottom=500;

	if (init) {
		Canvas->Brush->Color=0xFFFFFF;
		Canvas->FillRect(r);
	}

	for(x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			if(init|(Xold[x][y]!=X[x][y]))  {
			if((Xold[x][y]>99)&&(X[x][y]<99)){
				r.left=x*10;
				r.top=y*10;
				r.right=x*10+10;
				r.bottom=y*10+10;
				Canvas->Brush->Color=0xFFFFFF;
				Canvas->FillRect(r);
			}
			if(X[x][y]>99){
				PlotGates(x,y,X[x][y]-100,0);
				continue;
			}
			switch(X[x][y]){
				case 1:
					//ShowMessage("RED");
					Canvas->Brush->Color=0x0000FF;
					Canvas->Pen->Color=0x0000FF;
					break;
				case 2:
					//ShowMessage("Green");
					Canvas->Brush->Color=0x00FF00;
					Canvas->Pen->Color=0x00FF00;
					break;
				case 3:
					Canvas->Brush->Color=0xFF0000;
					Canvas->Pen->Color=0xFF0000;
					break;
				case 4:
					Canvas->Brush->Color=0x00FFFF;
					Canvas->Pen->Color=0x00FFFF;
					break;
				case 5:
					Canvas->Brush->Color=0xFF00FF;
					Canvas->Pen->Color=0xFF00FF;
					break;
				case 6:
					Canvas->Brush->Color=0xFFFF00;
					Canvas->Pen->Color=0xFFFF00;
					break;
				case 7:
					Canvas->Brush->Color=0x000000;
					Canvas->Pen->Color=0x000000;
					break;
				default:
					if(!init){
						Canvas->Brush->Color=0xFFFFFF;
						Canvas->Pen->Color=0xFFFFFF;
					}
					break;
			}
			if(!init|(init&&X[x][y])){
				m=10*x;n=10*y;
				Canvas->Pie(m,n,m+10,n+10,m,n,m,n);
			}
			}
		}
	}
	Szin();
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Paint(TObject *Sender)
{
	DrawOut(1);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::FormCreate(TObject *Sender)
{
	int x;
	//Load points
	/*
	X[4][2]=2;
	X[2][3]=1;
	X[3][4]=1;
	X[3][5]=1;
	X[5][6]=1;
	X[2][8]=1;
	X[2][9]=1;
	X[3][8]=1;
	X[20][20]=1;
	X[15][29]=1;
	X[16][29]=1;
	X[17][29]=1;
	X[23][22]=1;
	X[18][16]=1;
	X[10][28]=1;
	X[7][9]=1;
	X[23][32]=1;
	X[24][32]=1;
	X[25][32]=1;
	X[23][33]=1;
	X[23][34]=1;
	X[23][30]=1;
*/
	strcpy(iFILE,pre_FILE);
	strcpy(iRULEFILE,pre_RULEFILE);
	Load();
	//Draw
	SZIN=1;  Run=0;  tdelay=100;   Rule=4;  LGM=0;
	Timer1->Interval=tdelay;
	LoadGates();
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
	int x,y,nx,ny;
	int Xnew[SIZE][SIZE];
	int rulepoi,condtrue,orrulepoi,andpoi;

	if(!Run)return;

	for(x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			Xnew[x][y]=0;
		}
	}

	if(LGM){//LGM mode

		for(x=0;x<SIZE;x++){

			for(y=0;y<SIZE;y++){
				if(X[x][y]>99){

					switch(X[x][y]-100){
						case 0:
						case 4:
						case 8: nx=x+1;ny=y;if(nx>SIZE-1)nx=0;
							break;
						case 1:
						case 5:
						case 9: nx=x;ny=y+1;if(ny>SIZE-1)ny=0;
							break;
						case 2:
						case 6:
						case 10: nx=x-1;ny=y;if(nx<0)nx=SIZE-1;
							break;
						case 3:
						case 7:
						case 11: nx=x;ny=y-1;if(ny<0)ny=SIZE-1;
							break;
						case 12: nx=x;ny=y;
							break;
						case 13: nx=x;ny=y;
                        	break;
						default:
                        	ShowMessage("FATAL ERROR");
					}
					if(X[x][y]==112){//CROSS
						if((x<1)||(y<1)||(x>SIZE-2)||(y>SIZE-2)){
							Run=0;ShowMessage("ERROR CROSS IS IN WRONG PLACE!!");return;
						}
						if((X[x-1][y-1]==5)||(X[x-1][y-1]==6))X[x+1][y+1]=X[x-1][y-1];
						else if((X[x+1][y+1]==5)||(X[x+1][y+1]==6))X[x-1][y-1]=X[x+1][y+1];
						if((X[x-1][y+1]==5)||(X[x-1][y+1]==6))X[x+1][y-1]=X[x-1][y+1];
						else if((X[x+1][y-1]==5)||(X[x+1][y-1]==6))X[x-1][y+1]=X[x+1][y-1];
					}else if(X[x][y]==113){//D Flip flop
						if(X[x][y+1]==5){
							if(X[x+1][y-1]==3)X[x-1][y-1]=6;
                        	if(X[x+1][y-1]==1)X[x-1][y-1]=5;
						}
					}
					else X[nx][ny]=0;
					if((X[x][y]==100)||(X[x][y]==101)||(X[x][y]==102)||(X[x][y]==103)){
						if(NeN(x,y,1)==2)X[nx][ny]=5;
						else if(NeN(x,y,7)==0)X[nx][ny]=6;
					}
					if((X[x][y]==104)||(X[x][y]==105)||(X[x][y]==106)||(X[x][y]==107)){
						if(NeN(x,y,3)==2)X[nx][ny]=6;
						else if(NeN(x,y,7)==0)X[nx][ny]=5;
					}
					if((X[x][y]==108)||(X[x][y]==109)||(X[x][y]==110)||(X[x][y]==111)){
						if(NeN(x,y,1)==1)X[nx][ny]=6;
						else if(NeN(x,y,7)==0)X[nx][ny]=5;
					}
				}
			}

		}

	}


	for(x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			if (Rule==1) {    //Normal lifegame rules
				if((X[x][y])&&(NeN(x,y,-1)==2))Xnew[x][y]=X[x][y];
				else if(NeN(x,y,-1)==3)Xnew[x][y]=1;
			}
			if(Rule==2){     //Extended lifegame rules
				if((X[x][y])&&(NeN(x,y,-1)==2))Xnew[x][y]=X[x][y];
				else if(NeN(x,y,-1)==3)Xnew[x][y]=2;
				if(!X[x][y]&&(NeN(x,y,-1)>5))Xnew[x][y]=3;
			}
			if(Rule==3){     //Phoenix rules - walking bugs
				if((X[x][y]==0)&&((NeN(x,y,2)==1)&&((NeN(x,y,1)==3)||(NeN(x,y,1)==2))))Xnew[x][y]=2;
				if(X[x][y]==2)Xnew[x][y]=3;
				if((X[x][y]==3)&&(NeN(y,x,2)==1))Xnew[x][y]=0;
				if(X[x][y]==1)Xnew[x][y]=1;
			}
			if(Rule==4){     //Rules parsed from Rule.txt
				if(X[x][y]>99){
                	Xnew[x][y]=X[x][y];
					continue;
				}
				rulepoi=0;
				while((rulepoi<MAXRULE)&&(rules[rulepoi].valid)){
					if(X[x][y]==rules[rulepoi].prec){
						condtrue=0;	//OR condition check
						orrulepoi=0;
						while((!condtrue)&&(orrulepoi<8)&&(rules[rulepoi].cond[orrulepoi][0].valid)){
							condtrue=1;
							andpoi=0;
							while((condtrue)&&(andpoi<8)&&(rules[rulepoi].cond[orrulepoi][andpoi].valid)){
								if(NeN(x,y,rules[rulepoi].cond[orrulepoi][andpoi].elem)!=rules[rulepoi].cond[orrulepoi][andpoi].num)
									condtrue=0;
								andpoi++;
							}
							orrulepoi++;
						}
						if(condtrue)Xnew[x][y]=rules[rulepoi].succ;
						else if(rules[rulepoi].invs!=-1)Xnew[x][y]=rules[rulepoi].invs;
						if(!rules[rulepoi].cond[0][0].valid)Xnew[x][y]=rules[rulepoi].succ;
					}
					rulepoi++;
				}
			}
		}
	}
	//Copy
	for(x=0;x<SIZE;x++){
		for(y=0;y<SIZE;y++){
			Xold[x][y]=X[x][y];
			X[x][y]=Xnew[x][y];
		}
	}

	DrawOut(0);
}
//---------------------------------------------------------------------------



void __fastcall TForm1::Button1Click(TObject *Sender)
{
	Run=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	Run=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
	tdelay-=100;
	if(tdelay<1)tdelay=1;
	Timer1->Interval=tdelay;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
	tdelay+=100;
	Timer1->Interval=tdelay;
}
//---------------------------------------------------------------------------

//LOAD
void __fastcall TForm1::Button5Click(TObject *Sender)
{
	Load();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
	Rule=1;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
	Rule=2;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
	Rule=3;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
	Rule=4;
}
//---------------------------------------------------------------------------

//OPEN
void __fastcall TForm1::Button10Click(TObject *Sender)
{
	BYTE*memp;
	FILE*f;
	int fileHandler,x,pos;

	OpenDialog1->Filter="Text files (*.txt)|*.TXT";

	if(OpenDialog1->Execute()){
		strcpy(iRULEFILE,OpenDialog1->FileName.c_str());
		fileHandler = FileOpen(iRULEFILE, GENERIC_READ);
		if(fileHandler==-1) ShowMessage("File Open ERROR");
		else {
			memp=new BYTE [10000];
			for(x=0;x<10000;x++)memp[x]=0;
			FileRead(fileHandler, memp, 10000);
			FileClose(fileHandler);

			x=0;
			while((x<10000)&&(memp[x]!='#'))x++;

			if(x>9000){ShowMessage("ERROR no BMP file specified");return;}
			x++;pos=0;
			while((pos<100)&&(memp[x])&&(memp[x]!=13)){
				iFILE[pos]=memp[x];
				x++;pos++;
			}
			iFILE[pos]=0;
			while((x<10000)&&(memp[x]!='%'))x++;
			if((memp[x+1]=='L')&&(memp[x+2]=='G')&&(memp[x+3]=='M')&&(memp[x]=='%'))
				LGM=1;
			delete memp;
		}
	}
	//ShowMessage(iRULEFILE);
	Load();

}
//---------------------------------------------------------------------------

void __fastcall TForm1::mouse(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int x, int y)
{
	x=x/10;y=y/10;
	if(Button==mbLeft){
		if(X[x][y])X[x][y]=0;
		else X[x][y]=SZIN;
		DrawOut(0);
		Xold[x][y]=X[x][y];
	}
	if(Button==mbRight){
		SZIN=X[x][y];
		Szin();
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::key(TObject *Sender, char &Key)
{
	int x,y;
	//R: Start/Stop
	if(Key=='r'){
		if(Run)Run=0;
		else Run=1;
	}
	//L: Load
	if(Key=='l'){
		Load();
	}
	//N: New empty page
	if(Key=='n'){
		for(x=0;x<SIZE;x++)
			for(y=0;y<SIZE;y++){
				X[x][y]=0;
				Xold[x][y]=0;
			}
		DrawOut(1);
	}
	//W: speed up
	if(Key=='w'){
		tdelay-=100;
		if(tdelay<1)tdelay=1;
		Timer1->Interval=tdelay;
	}
	//S: Speed down
	if(Key=='s'){
		tdelay+=100;
		Timer1->Interval=tdelay;
	}
	//C: change color
	if(Key=='c'){
		SZIN++;
		if(SZIN>7)SZIN=0;
		Szin();
	}
	//G: change gate
	if(Key=='g'){
		if(SZIN<100)SZIN=100;
		else {
			SZIN++;if(SZIN>113)SZIN=100;
		}
		Szin();
	}

	return;
	//T:test
	if(Key=='t'){
		HDC hdc=Canvas->Handle;
		HDC memDC = CreateCompatibleDC ( hdc );
		HBITMAP memBM = CreateCompatibleBitmap ( hdc,100,100 );
		SelectObject ( memDC, memBM );

		//Ellipse(memDC,0,0,100,100);
		//SetPixel(memDC,20,20,0x123456);
		//SetPixel(memDC,21,20,0x123456);
		//SetPixel(memDC,21,21,0x123456);

		int fileHandler = FileOpen("dot.pic", GENERIC_READ);
		if(fileHandler==-1) ShowMessage("BMP - File Open ERROR");
		else {
			BYTE*memp=new BYTE [1000];
			FileRead(fileHandler, memp, 1000);
			FileClose(fileHandler);
			int p=0;
			int r,g,b;
			for(y=0;y<10;y++){
				while(memp[p]!=':')p++;
				for(x=0;x<10;x++){
					r=0;g=0;b=0;
					switch(memp[p++]){
						case 'R': r=0xFF;
							break;
						case 'G': g=0xFF;
							break;
						case 'B': b=0xFF;
							break;
						case 'Y': r=0xFF; g=0xFF;
							break;
						case 'C': b=0xFF; g=0xFF;
							break;
						case 'M': b=0xFF; r=0xFF;
							break;
						case '0': r=0xFF; g=0xFF; b=0xFF;
							break;
						case ' ': r=0xFF; g=0xFF; b=0xFF;
							break;
						default:
							break;
					}
					SetPixel(memDC,x+10,y+10,RGB(r,g,b));
				}
			}
			delete memp;
		}

		BitBlt(hdc,10,10,100,100,memDC,0,0,SRCCOPY);
		BitBlt(hdc,200,100,100,100,memDC,0,0,SRCCOPY);
	}
}
//---------------------------------------------------------------------------


//Save configuration into an own file format
void __fastcall TForm1::Button11Click(TObject *Sender)
{
	int x=0,y,p,resp;
	char name[100];
	FILE*f;

	resp=MessageBox(NULL,"Really want to SAVE?","FILE",MB_OKCANCEL);
	if(resp==IDCANCEL ){return;}

	while(iFILE[x]!='.'){name[x]=iFILE[x]; x++;}
	name[x]='.';name[x+1]='d';name[x+2]='o';name[x+3]='t';name[x+4]=0;

	f=fopen(name,"wb");
	if(f==NULL) ShowMessage("SAVE - File Open ERROR");
	else {
		p=0;
		for(x=0;x<SIZE;x++)
			for(y=0;y<SIZE;y++)
				putc(X[x][y],f);
		fclose(f);
	}
}
//---------------------------------------------------------------------------

